/* 

Copyright (C) 2003-2004 Yves Schmid (www.garagecube.com)

Author(s): Yves Schmid

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     GNU General Public License for more details.

You should have received a copy of the GNU General Public Licensealong with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#import <Foundation/Foundation.h>

class OMediaCanvas;

#define COSMIC_NBRUSHES (5*5)
#define COSMIC_NIMAGES (20)

enum cosmic_Tool
{
	cosmic_Draw,
	cosmic_ConnectedDraw,
	cosmic_Rotate,
	cosmic_Scroll,
	cosmic_Scale
};

@interface CosmicPalette : NSObject 
{
	IBOutlet NSPanel		*panel;

	IBOutlet NSTabView		*brushTabView;
	IBOutlet NSTabView		*toolInfoTabView;

    IBOutlet NSSlider 		*rotationSpeedSlider;
	IBOutlet NSTextField	*rotationSpeedTextField;

    IBOutlet NSSlider 		*scrollSpeedSlider;
	IBOutlet NSTextField	*scrollSpeedTextField;

    IBOutlet NSSlider 		*scaleSpeedSlider;
	IBOutlet NSTextField	*scaleSpeedTextField;
	IBOutlet NSTextField	*scaleStartTextField;
	IBOutlet NSTextField	*scaleEndTextField;
    IBOutlet NSButton 		*scalePingpongCheckbox;

	IBOutlet NSTextField	*manuallySetXTextField;
	IBOutlet NSTextField	*manuallySetYTextField;
	IBOutlet NSTextField	*manuallySetAngleTextField;
	IBOutlet NSTextField	*manuallySetZoomTextField;

    IBOutlet NSSlider 		*fpsSlider;
	IBOutlet NSTextField	*fpsTextField;

    IBOutlet NSColorWell	*clearColorWell;

    IBOutlet NSColorWell	*startColorWell;
    IBOutlet NSColorWell	*endColorWell;
    IBOutlet NSButton 		*colorCircularSlider;
    IBOutlet NSSlider 		*colorSpeedSlider;



    IBOutlet NSMatrix		*brushMatrix;
    IBOutlet NSButton		*drawShadowCheckbox;
    IBOutlet NSButton		*crossCheckbox;
    IBOutlet NSButton		*bufferCheckbox;

    IBOutlet NSButton		*toolDrawButton,*toolConnectedDrawButton,
							*toolRotateButton,*toolScrollButton,*toolScaleButton;

    IBOutlet NSSlider 		*imageSlider;
	IBOutlet NSImageView	*imageView;
	IBOutlet NSTextField	*imageTextField;

	OMediaCanvas			*brushes[COSMIC_NBRUSHES];
	OMediaCanvas			*currentBrush;
	OMediaCanvas			*currentBrushShadow;
	
	float					currentColorState;
	int						currentColorStateInt;

	BOOL					dirtyImages[COSMIC_NIMAGES];
	NSImage					*images[COSMIC_NIMAGES];
	OMediaCanvas			*imageCanvas[COSMIC_NIMAGES];
	
	cosmic_Tool				currentTool;
	
}

+(CosmicPalette*)getMain;

-(OMediaCanvas*)getCurrentBrush;

-(IBAction)brushChanged:(id)sender;
-(IBAction)colorChanged:(id)sender;
-(IBAction)imageChanged:(id)sender;
-(IBAction)currentImagePosChanged:(id)sender;
-(IBAction)toolChanged:(id)sender;

-(void)rebuildWithColorState:(float)colorInterpolateState;

-(IBAction)showHelp:(id)sender;


@end
